'use client'
import { useQuery, useMutation } from '@tanstack/react-query'
import { ListArguments } from '@/types/listRequest'

const fetchGraphQlBuildsList = async (params: ListArguments): Promise<any> => {
    console.log('Fetching test data from local API');
    const { limit, skip, sort, filters } = params;
    try {
        const res = await fetch('/api/builds/list', { method: 'POST', cache: 'no-store', credentials: "include", body: JSON.stringify({ limit, skip, sort, filters }) });
        if (!res.ok) { const errorText = await res.text(); console.error('Test data API error:', errorText); throw new Error(`API error: ${res.status} ${res.statusText}`) }
        const data = await res.json();
        return { data: data.data, totalCount: data.totalCount }
    } catch (error) { console.error('Error fetching test data:', error); throw error }
};

const fetchGraphQlDeleteBuild = async (uuid: string): Promise<boolean> => {
    console.log('Fetching test data from local API');
    try {
        const res = await fetch(`/api/builds/delete?uuid=${uuid}`, { method: 'GET', cache: 'no-store', credentials: "include" });
        if (!res.ok) { const errorText = await res.text(); console.error('Test data API error:', errorText); throw new Error(`API error: ${res.status} ${res.statusText}`) }
        const data = await res.json();
        return data
    } catch (error) { console.error('Error fetching test data:', error); throw error }
};

export function useGraphQlBuildsList(params: ListArguments) {
    return useQuery({ queryKey: ['graphql-builds-list', params], queryFn: () => fetchGraphQlBuildsList(params) })
}

export function useDeleteBuildMutation() {
    return useMutation({
        mutationFn: ({ uuid }: { uuid: string }) => fetchGraphQlDeleteBuild(uuid),
        onSuccess: () => { console.log("Person deleted successfully") },
        onError: (error) => { console.error("Delete person failed:", error) },
    })
}
